
#include <avr/io.h>
#include "spi.h"

void spi_init()  {

	DDRB  |= (1<<DDRB2) | (1<<DDRB1) | (1<<DDRB0); //Atmega128a SPI MODE,
	PORTB |= (1<<PORTB2) | (1<<PORTB1);

	SPCR  = (1<<SPIE); //SPI ͷƮ Ȱȭ
	SPCR |= (1<<SPE);  //SPI  Ȱȭ
    SPCR |= (1<<MSTR); /// , 1:͸, 0: 

	SS_DE();
    //sei(); //SREG = 0x80; (1<<SPIE) SREG Ȱȭ Ѵ,
}

uint8_t spi_send(uint8_t data){

	SS_EN();

	SPDR=data; //1Ʈ 꿡 ,
	while(!(SPSR & (1<<SPIF)));

    return SPDR;

}
uint8_t spi_read(){

	SS_EN();

	SPDR = 0;
	while(!(SPSR & (1<<SPIF)));

	return SPDR;

}
