
#include <avr/io.h>

#include "SPI/spi.h"
#include "Ethernet/socket.h"
#include "Ethernet/wizchip_conf.h"

#define MAX_BUF_SIZE 2048 //RX ִ밪

unsigned char rx_buf[2048]; //Rx  ø̼
unsigned char *rx_ptr;

// ʱȭ
uint8_t test_socket = 0;

void socket_init(SOCKET s,uint16_t port,uint8_t flag,uint8_t udp_mode,uint8_t client_mode){
	
	 if (udp_mode==1)
	 {
		
	 }
	 else { //TCP 
		 
		 test_socket = socket(s,Sn_MR_TCP,port,flag);
		 setSn_MR(s, MR_PB); //ش Ͽ  ping Ȱȭ
		 
		 if (client_mode==1) connect(s,ConnIP,5000); //Ŭ̾Ʈ  ConnIP 
		 else listen(s); // 
	 }
}

	//NIC metrics for WORK PC
    wiz_NetInfo netInfo = { 
	.mac  = {0x00,0x08,0xdc,0x11,0x11,0x11}, // Mac address
    .ip   = {192, 168, 0, 199},  // IP address
    .sn   = {255, 255, 255, 0},  // Subnet mask
    .gw   = {192, 168, 0, 1},    // Gateway address
	.dns =  {8,8,8,8},			 // DNS address (google dns)
    .dhcp = NETINFO_STATIC       //Static IP configuration
	};
	

	void cs_sel() {
		SS_EN();
	}

	void cs_desel() {
		SS_DE();
	}

	uint8_t spi_rb(void) {
		uint8_t rbuf;
		//HAL_SPI_Receive(&hspi1, &rbuf, 1, HAL_MAX_DELAY);
		rbuf = spi_read();
		return rbuf;
	}

	void spi_wb(uint8_t b) {
		//HAL_SPI_Transmit(&hspi1, &b, 1, HAL_MAX_DELAY);
		spi_send(b);
	}

	void IO_LIBRARY_Init(void) {
		
		uint8_t bufSize[] = {2, 2, 2, 2, 2, 2, 2, 2};

		reg_wizchip_cs_cbfunc(cs_sel, cs_desel);
		wizchip_init(bufSize, bufSize);
		wizchip_setnetinfo(&netInfo);
				
		reg_wizchip_spi_cbfunc(spi_rb, spi_wb);
		
	}
	
int main(){

SOCKET i; //Ϲȣ  

spi_init();
IO_LIBRARY_Init();
// ϸ ping ׽Ʈ  ,?
//׷ W5500 ⿡ pc ping 192.168.0.199 ϸ  Ҽ ٰ ׿,
//ȭ    ֽϴ,

socket_init(0,5000,0,0,0); // ѹ 5000 : TCP ʱȭ

   while(1){
	   
	   //  üũ
	   for ( i=0; i<_WIZCHIP_SOCK_NUM_; i++){
		   
		   switch (getSn_SR(i)) {
			   
			   // 0x17϶  
			   case SOCK_ESTABLISHED:
			           
			            break;
			   
			   //0x1C: Ŭ̾Ʈ   ,
			   case SOCK_CLOSE_WAIT:
			        
					   break;
			   
			   //0x00:  
			   case SOCK_CLOSED:
			          
					   //TCP  ٽ ʱȭ
					   socket_init(i,5000,0,0,0);
					   break;
					
			   default:
			           break;		
					
		   } //switch
		} //for
	  } //while
	  
	  return 0;
}

